diff -ruN ../nakedmudv3.7/lib/pymodules/account_handler.py lib/pymodules/account_handler.py
--- ../nakedmudv3.7/lib/pymodules/account_handler.py	2008-05-31 00:18:11.000000000 -0400
+++ lib/pymodules/account_handler.py	2009-03-02 12:37:00.000000000 -0500
@@ -4,7 +4,7 @@
 The login and creation of accounts, and handles all account procedures, loading
 and deleting, of characters.
 '''
-import mud, mudsys, char, hooks, account, socket, event, telnetlib
+import mud, mudsys, char, hooks, account, socket, event, telnetlib, utils
 
 # control sequences for squelching passwords
 squelch   = telnetlib.IAC + telnetlib.WILL + telnetlib.ECHO
@@ -17,103 +17,112 @@
     return (len(name) > 3 and len(name) < 13 and
             name[0].isalpha() and name.isalnum())
 
-def acct_name_prompt(sock):
-    sock.send_raw("What is your account name? ")
+def login_method_prompt(sock):
+    sock.send_raw("Choose an option: ")
 
 def acct_new_password_prompt(sock):
-    sock.send_raw("What is your new password? " + squelch)
+    sock.send_raw("\r\nWhat is your new password? " + squelch)
 
 def acct_password_prompt(sock):
     sock.send_raw("What is your password? " + squelch)
 
-def acct_confirm_password_prompt(sock):
-    sock.send_raw("\r\nVerify your password? " + squelch)
-
 def acct_wait_dns_prompt(sock):
-    sock.send_raw("Resolving your internet address, have patience... ")
+    sock.send_raw(" Resolving your internet address, please have patience... ")
 
-def acct_finish_prompt(sock):
-    sock.send_raw("{c\r\n*** Press enter to finish account creation:{n ") 
+def try_create_account(sock, name, psswd):
+    if mudsys.account_exists(name):
+        return False
+    elif mudsys.account_creating(name):
+        return False
+    elif not check_acct_name(name):
+        return False
+    else:
+        # creating a new account
+        mud.log_string("Account '" + name + "' is trying to create.")
 
-def acct_finish_handler(sock, arg):
-    # pop our input handler for finishing account generation
-    sock.pop_ih()
+        # create our new account
+        acct = mudsys.create_account(name)
+        if acct == None:
+            return False
+        else:
+            mudsys.attach_account_socket(acct, sock)
+            mudsys.set_password(acct, psswd)
+            sock.pop_ih()
+            sock.push_ih(acct_menu_handler, acct_main_menu)
 
-    # log that the account created
-    mud.log_string("New account '" + sock.account.name + "' has created.")
+            #sock.push_ih(acct_finish_handler, acct_finish_prompt)
 
-    # register and save the account to disk
-    mudsys.do_register(sock.account)
+            # log that the account created
+            mud.log_string("New account '" + acct.name + "' has created.")
 
-def acct_wait_dns_handler(sock, arg):
-    # do nothing
-    return
+            # register and save the account to disk
+            mudsys.do_register(acct)
+
+            return True
+    return False
 
-def acct_name_handler(sock, arg):
-    '''the first prompt a socket encounters; enter a name of an account or
-       a new name of an account to create one'''
-    if arg and mudsys.account_exists(arg):
-        # logging on to an already existing account
-        mud.log_string("Account '" + arg + "' is trying to connect.")
-        acct = mudsys.load_account(arg)
+def try_load_account(sock, name, psswd):
+    '''Attempt to load an account with the given name and password.'''
+    if not mudsys.account_exists(name):
+        return False
+    else:
+        acct = mudsys.load_account(name)
+        if not mudsys.password_matches(acct, psswd):
+            return False
 
-        # attach our account to our socket. Put in mudsys to prevent scripts
-        # from messing around with account and socket connections
+        # successful load
         mudsys.attach_account_socket(acct, sock)
         sock.pop_ih()
         sock.push_ih(acct_menu_handler, acct_main_menu)
-        sock.push_ih(acct_password_handler, acct_password_prompt)
-
-    elif not check_acct_name(arg):
-        sock.send(mud.format_string("That is an invalid account name. Your " \
-                                    "account name must only consist of " \
-                                    "characters and numbers, and it must be " \
-                                    "4 and 12 characters in length. The first "\
-                                    "character MUST be a letter. Please pick "\
-                                    "another.", False))
-
-    elif mudsys.account_creating(arg):
-        sock.send("An account with that name is already creating.")
+        return True
+    return False
 
-    else:
-        # creating a new account
-        mud.log_string("Account '" + arg + "' is trying to create.")
+def login_method_handler(sock, arg):
+    args = arg.split()
+    if len(args) == 0:
+        return
+    args[0] = args[0].lower()
 
-        # create our new account
-        acct = mudsys.create_account(arg)
-        if acct == None:
-            sock.send("Could not create an account with that name.")
+    if "create".startswith(args[0]):
+        if len(args) != 3:
+            return
+        elif mudsys.account_exists(args[1]):
+            sock.send("{cAn account by that name already exists.{n\r\n")
+        elif not check_acct_name(args[1]):
+            txt = "{cThat is an invalid account name. Your account name must "\
+                  "only consist of characters and numbers, and it must be " \
+                  "4 and 12 characters in length. The first character MUST be "\
+                  "a letter. Please pick another.{n"
+            sock.send(mud.format_string(txt, False))
+
+        elif not try_create_account(sock, args[1], args[2]):
+            sock.send("Your account was unable to be created.")
+
+    elif "load".startswith(args[0]):
+        if len(args) != 3:
+            return
+        elif not try_load_account(sock, args[1], args[2]):
+            sock.send("{cInvalid account name or password.{n\r\n")
+    elif "guest".startswith(args[0]):
+        if (mudsys.sys_getval("lockdown") != '' and
+            not utils.is_keyword(mudsys.sys_getval("lockdown"), "player")):
+            sock.send("{cThe mud is currently locked out to new players.{n\r\n")
         else:
-            mudsys.attach_account_socket(acct, sock)
             sock.pop_ih()
-            sock.push_ih(acct_menu_handler, acct_main_menu)
-            sock.push_ih(acct_finish_handler, acct_finish_prompt)
-            sock.push_ih(acct_confirm_password_handler, acct_confirm_password_prompt)
-            sock.push_ih(acct_new_password_handler, acct_new_password_prompt)
+            hooks.run("create_guest", hooks.build_info("sk", (sock,)))
 
+def acct_wait_dns_handler(sock, arg):
+    # do nothing
+    return
 
 def acct_new_password_handler(sock, arg):
     '''asks a new account for a password'''
+    sock.send_raw(unsquelch)
     if len(arg) > 0:
         # put in mudsys to prevent scripts from messing with passwords
         mudsys.set_password(sock.account, arg)
         sock.pop_ih()
 
-def acct_confirm_password_handler(sock, arg):
-    '''checks to see if our argument matches our password; if not, we re-enter
-       our old password'''
-    # password functions put in mudsys to prevent scripts from
-    # messing with passwords
-    if not mudsys.password_matches(sock.account, arg):
-        sock.send("Passwords do not match.")
-        sock.pop_ih()
-        sock.push_ih(acct_confirm_password_handler,acct_confirm_password_prompt)
-        sock.push_ih(acct_password_handler, acct_password_prompt)
-    else:
-        # Password matches. Keep it and go down a level
-        sock.send_raw(unsquelch)
-        sock.pop_ih()
-
 def acct_password_handler(sock, arg):
     '''asks an account to verify its password'''
     # password functions put in mudsys to prevent scripts from
@@ -135,16 +144,14 @@
             return ch
     return None
 
-def acct_load_char(sock, arg):
+def acct_load_char(sock, name):
     '''loads a character attached to the account. Argument supplied must be a
-       numeric value corresponding to the character'''
-    arg = int(arg)
-    if arg >= len(sock.account.characters()) or arg < 0:
-        sock.send("Invalid choice!")
+       name of the corresponding character'''
+    chars = sock.account.characters()
+    
+    if not name.lower() in [n.lower() for n in sock.account.characters()]:
+        sock.send("A character by that name does not exist on your account.")
     else:
-        # get the name
-        name = sock.account.characters()[arg]
-
         # first, try a reconnect
         ch = find_reconnect(name)
 
@@ -161,8 +168,11 @@
             if old_sock != None:
                 old_sock.close()
             mud.log_string(ch.name + " has reconnected.")
+            # ch.act("clear")
             ch.send("You take over a body already in use.")
-            sock.push_ih(mudsys.handle_cmd_input, mudsys.show_prompt)
+            ch.act("look")
+            hooks.run("reconnect", hooks.build_info("ch", (ch,)))
+            sock.push_ih(mudsys.handle_cmd_input, mudsys.show_prompt, "playing")
 
         else:
             # load our character. Put in mudsys to prevent scripts from using it
@@ -179,7 +189,9 @@
                 mudsys.attach_char_socket(ch, sock)
                 if mudsys.try_enter_game(ch):
                     mud.log_string(ch.name + " has entered the game.")
-                    sock.push_ih(mudsys.handle_cmd_input, mudsys.show_prompt)
+                    sock.push_ih(mudsys.handle_cmd_input, mudsys.show_prompt,
+                                 "playing")
+                    # ch.act("clear")
                     ch.page(mud.get_motd())
                     ch.act("look")
                     hooks.run("enter", hooks.build_info("ch rm", (ch, ch.room)))
@@ -195,18 +207,31 @@
     '''parses account commands (new character, enter game, quit, etc)'''
     if len(arg) == 0:
         return
-    arg = arg[0].upper()
-    if arg.isdigit():
-        acct_load_char(sock, arg)
-    elif arg == 'Q':
+
+    args = arg.split()
+    args[0] = args[0].upper()
+    
+    if args[0].isdigit():
+        opts = sock.account.characters()
+        arg  = int(args[0])
+        if arg < 0 or arg >= len(opts):
+            sock.send("Invalid choice!")
+        else:
+            acct_load_char(sock, opts[arg])
+    elif args[0] == 'L':
+        if len(args) == 1:
+            sock.send("Which character would you like to load?")
+        else:
+            acct_load_char(sock, args[1])
+    elif args[0] == 'Q' or "QUIT".startswith(args[0]):
         sock.send("Come back soon!")
         mudsys.do_save(sock.account)
         sock.close()
-    elif arg == 'P':
-        sock.push_ih(acct_confirm_password_handler,acct_confirm_password_prompt)
+    elif args[0] == 'P':
+        # sock.push_ih(acct_confirm_password_handler,acct_confirm_password_prompt)
         sock.push_ih(acct_new_password_handler, acct_new_password_prompt)
         sock.push_ih(acct_password_handler, acct_password_prompt)
-    elif arg == 'N':
+    elif args[0] == 'N':
         if "player" in [x.strip() for x in mudsys.sys_getval("lockdown").split(",")]:
             sock.send("New characters are not allowed to be created at this time.")
         else:
@@ -219,7 +244,7 @@
        has attached. Prints three names per line.'''
     num_cols   = 3
     print_room = (80 - 10*num_cols)/num_cols
-    fmt        = "  {c%2d{g) %-" + str(print_room) + "s"
+    fmt        = "  {c%2d{n) %-" + str(print_room) + "s"
 
     sock.send("{w\r\nPlay a Character:")
     i = 0
@@ -234,27 +259,89 @@
 
 def acct_main_menu(sock):
     '''displays the main menu for the account and asks for a command'''
-    if len(sock.account.characters()) > 0:
-        display_acct_chars(sock)
+    line_buf = "%-38s" % " "
 
-    sock.send("\r\n{wAdditional Options:")
-    sock.send("  {g[{cP{g]assword change")
-    sock.send("  {g[{cN{g]new character\r\n")
-    sock.send_raw("Enter choice, or Q to quit:{n ")
+    # make the account menu look pretty
+    img = ["+--------------------------------------+",
+           "|                                      |",
+           "|                                      |",
+           "|                                      |",
+           "|                                      |",
+           "|                                      |",
+           "|                                      |",
+           "|                                      |",
+           "|                                      |",
+           "|                                      |",
+           "|               I M A G E              |",
+           "|                H E R E               |",
+           "|                                      |",
+           "|                                      |",
+           "|                                      |",
+           "|                                      |",
+           "|                                      |",
+           "|                                      |",
+           "|                                      |",
+           "|                                      |",
+           "|                                      |",
+           "|                                      |",
+           "+--------------------------------------+"]
+
+    # the lines for displaying our account options
+    opts  = [ ]
+    chars = sock.account.characters()
+    chars.sort()
+    if len(chars) > 0:
+        opts.append("  {wPlay A Character:                   ")
+        for i in range(len(chars)):
+            opts.append("    {n[{c%1d{n] %-30s" % (i,chars[i]))
+        opts.append(line_buf)
+
+    # append our other displays
+    opts.append("  {wAccount Management:                 ")
+    opts.append("    {n[{cP{n]assword change                 ")
+    opts.append("    {n[{cN{n]ew character                   ")
+    opts.append("    {n[{cL{n]oad character <name>           ")
+    opts.append(line_buf)
+    opts.append(line_buf)
+    opts.append(line_buf)
+
+    # fill up our height to be in line with the image
+    while len(opts) < len(img) - 2:
+        opts.insert(0, line_buf)
+
+    # append our title
+    opts.insert(1, "            {nW E L C O M E  T O        ")
+    opts.insert(2, "             {nN A K E D M U D          ")
+            
+    # display all of our info
+    sock.send("")
+    for i in range(max(len(opts), len(img))):
+        if i < len(opts):
+            sock.send_raw(opts[i])
+        else:
+            sock.send_raw(line_buf)
+        if i < len(img):
+            sock.send_raw("{n%s" % img[i])
+        sock.send("")
+        
+    sock.send_raw("{nEnter choice, or Q to quit: ")
 
 
 
 ################################################################################
 # events for blocking action when dns lookup is in progress
 ################################################################################
-def dns_check_event(no_owner, unused, info):
+def dns_check_event(owner, void, info):
     sock, = hooks.parse_info(info)
-    if sock.can_use:
-        sock.send("Lookup complete.")
+    if sock != None and sock.can_use:
+        sock.send(" Lookup complete.")
+        sock.send("================================================================================")
+        sock.send(mud.get_greeting())
         sock.pop_ih()
         sock.bust_prompt()
+        # mud.log_string("new connection from " + sock.hostname)
     else:
-        event.start_event(None, 0.1, dns_check_event, None, info)
+        event.start_event(None, 0.2, dns_check_event, None, info)
 
 
 
@@ -264,14 +351,26 @@
 def account_handler_hook(info):
     # put a nonfunctional prompt up while waiting for the DNS to resolve
     sock, = hooks.parse_info(info)
-    sock.push_ih(acct_name_handler, acct_name_prompt)
+    sock.push_ih(login_method_handler, login_method_prompt)
+    mud.log_string("new socket, %d, attempting to connect" % sock.uid)
+    sock.send(mud.get_greeting())
+    sock.send("== Options Are ================================================================")
+    sock.send("    Load account   : load   <account> <password>")
+    sock.send("    Create account : create <account> <password>")
+    sock.send("    Play as guest  : guest")
+    sock.send("===============================================================================")
+    sock.send("")
+
+    '''
     sock.push_ih(acct_wait_dns_handler, acct_wait_dns_prompt)
-    event.start_event(None, 0.1, dns_check_event, None, info)
+    sock.send("================================================================================")
+    event.start_event(None, 0.2, dns_check_event, None, info)
+    '''
 
 def copyover_complete_hook(info):
     sock, = hooks.parse_info(info)
     sock.push_ih(acct_menu_handler, acct_main_menu)
-    sock.push_ih(mudsys.handle_cmd_input, mudsys.show_prompt)
+    sock.push_ih(mudsys.handle_cmd_input, mudsys.show_prompt, "playing")
 
 
 
diff -ruN ../nakedmudv3.7/lib/pymodules/char_gen.py lib/pymodules/char_gen.py
--- ../nakedmudv3.7/lib/pymodules/char_gen.py	2008-12-06 00:20:20.000000000 -0500
+++ lib/pymodules/char_gen.py	2009-03-02 03:10:23.000000000 -0500
@@ -16,17 +16,19 @@
 
 def cg_name_handler(sock, arg):
     if not check_char_name(arg):
-        sock.send("Illegal name, please pick another.")
+        sock.send("{cIllegal name, please pick another.{n\r\n")
     elif mudsys.player_exists(arg):
-        sock.send("A player with that name already exists.")
+        sock.send("{cA player with that name already exists.{n\r\n")
     elif mudsys.player_creating(arg):
-        sock.send("A player is already being created with that name.")
+        sock.send("{cA player is already being created with that name.{n\r\n")
+    elif arg.lower().startswith("guest"):
+        sock.send("{cCharacter names cannot begin with 'guest'.{n\r\n")
     else:
         name = arg[0].upper() + arg[1:]
         ch = mudsys.create_player(name)
 
         if ch == None:
-            sock.send("Illegal name, please pick another.")
+            sock.send("{cIllegal name, please pick another.{n\r\n")
         else:
             mudsys.attach_char_socket(ch, sock)
             ch.rdesc = ch.name + " is here."
@@ -37,16 +39,15 @@
         result = {
             'M' : 'male',
             'F' : 'female',
-            'N' : 'neutral'
             }[arg[0].upper()]
         sock.ch.sex = result
         sock.pop_ih()
-    except KeyError:
-        sock.send("Invalid sex, try again.")
+    except:
+        sock.send("{cInvalid sex, try again.{n\r\n")
 
 def cg_race_handler(sock, arg):
     if not mud.is_race(arg, True):
-        sock.send("Invalid race selection, try again.")
+        sock.send("{cInvalid race selection, try again.{n\r\n")
     else:
         sock.ch.race = arg.lower()
         sock.pop_ih()
@@ -57,9 +58,6 @@
 
     # log that the character created
     mud.log_string("New player: " + sock.ch.name + " has entered the game.")
-
-    # send them the motd
-    sock.ch.page(mud.get_motd())
     
     # register and save him to disk and to an account
     mudsys.do_register(sock.ch)
@@ -70,11 +68,17 @@
     # run the init_player hook
     hooks.run("init_player", hooks.build_info("ch", (sock.ch,)))
     
-    # attach him to his account and save the accoutn
+    # attach him to his account and save the account
     sock.account.add_char(sock.ch)
     mudsys.do_save(sock.account)
     mudsys.do_save(sock.ch)
+
+    # clear their screen
+    sock.ch.act("clear")
     
+    # send them the motd
+    sock.ch.page(mud.get_motd())
+
     # make him look at the room
     sock.ch.act("look")
 
@@ -85,7 +89,7 @@
     sock.send_raw("What is your character's name? ")
 
 def cg_sex_prompt(sock):
-    sock.send_raw("What is your sex (M/F/N)? ")
+    sock.send_raw("What is your sex (M/F)? ")
 
 def cg_race_prompt(sock):
     sock.send("Available races are: ")
@@ -102,19 +106,60 @@
 ################################################################################
 def char_gen_hook(info):
     sock, = hooks.parse_info(info)
-    sock.push_ih(mudsys.handle_cmd_input, mudsys.show_prompt)
+    sock.push_ih(mudsys.handle_cmd_input, mudsys.show_prompt, "playing")
     sock.push_ih(cg_finish_handler, cg_finish_prompt)
     sock.push_ih(cg_race_handler, cg_race_prompt)
     sock.push_ih(cg_sex_handler, cg_sex_prompt)
     sock.push_ih(cg_name_handler, cg_name_prompt)
 
+def guest_gen_hook(info):
+    sock, = hooks.parse_info(info)
+    sock.push_ih(mudsys.handle_cmd_input, mudsys.show_prompt, "playing")
+
+    # make the guest character
+    ch = mudsys.create_player("Guest")
+
+    # oops...
+    if ch == None:
+        sock.send("Sorry, there were issues creating a guest account.")
+        sock.close()
+
+    mudsys.attach_char_socket(ch, sock)
+    ch.rdesc = "a guest player is here, exploring the world."
+    ch.name  = ch.name + str(ch.uid)
+    ch.race  = "human"
+
+    # log that the character created
+    mud.log_string("Guest character created (id %d)." % ch.uid)
+
+    # make him exist in the game for functions to look him up
+    mudsys.try_enter_game(ch)
+
+    # run the init_player hook
+    hooks.run("init_player", hooks.build_info("ch", (ch,)))
+
+    # clear our screen
+    ch.act("clear")
+
+    # send them the motd
+    ch.page(mud.get_motd())
+    
+    # make him look at the room
+    ch.act("look")
+
+    # run our enter hook
+    hooks.run("enter", hooks.build_info("ch rm", (ch, ch.room)))
+
 
 
 ################################################################################
 # loading and unloading the module
 ################################################################################
 hooks.add("create_character", char_gen_hook)
+hooks.add("create_guest",     guest_gen_hook)
 
 def __unload__():
     '''removes the hooks for character generation'''
     hooks.remove("create_character", char_gen_hook)
+    hooks.remove("create_guest",     guest_gen_hook)
+
diff -ruN ../nakedmudv3.7/lib/pymodules/cmd_admin.py lib/pymodules/cmd_admin.py
--- ../nakedmudv3.7/lib/pymodules/cmd_admin.py	2008-12-06 00:20:20.000000000 -0500
+++ lib/pymodules/cmd_admin.py	2009-03-02 01:43:35.000000000 -0500
@@ -7,10 +7,25 @@
 ################################################################################
 from mud import *
 from mudsys import add_cmd
-import mudsys, inform, char, string
+import mudsys, inform, string, mudsock, mud, hooks
+import room as mudroom
+import char as mudchar
+import obj  as mudobj
 
 
 
+################################################################################
+# local variables
+################################################################################
+
+# a list of current instances, and their source zones
+curr_instances = [ ]
+
+
+
+################################################################################
+# game commands
+################################################################################
 def cmd_shutdown(ch, cmd, arg):
     '''Shuts the mud down.'''
     mudsys.do_shutdown()
@@ -36,7 +51,7 @@
          > repeat 20 load obj beer@drinks
        '''
     try:
-        times, arg = parse_args(ch, True, cmd, arg, "int string")
+        times, arg = parse_args(ch, True, cmd, arg, "int(times) string(command)")
     except: return
 
     if times < 1:
@@ -90,7 +105,7 @@
         mudsys.sys_setval("lockdown", arg)
 
         # kick out everyone who we've just locked out
-        for ch in char.char_list():
+        for ch in mudchar.char_list():
             if ch.is_pc and not ch.isInGroup(arg):
                 ch.send("The mud has just been locked down to you.")
                 mudsys.do_save(ch)
@@ -104,7 +119,7 @@
        current room.'''
     try:
         found, type, arg = parse_args(ch, True, cmd, arg,
-                                      "{ room ch.world.noself } string")
+                                      "{ room ch.world.noself } string(command)")
     except: return
 
     # figure out what room we're doing the command at
@@ -124,19 +139,19 @@
     if ch == vict:
         ch.send("Why don't you just try doing it?")
     elif vict.isInGroup("admin"):
-        ch.send("But " + vict.name + " has just as many priviledges as you!")
+        ch.send("But " + ch.see_as(vict) + " has just as many priviledges as you!")
     else:
         ch.send("You force " + vict.name + " to '" + cmd + "'")
-        vict.send(inform.see_char_as(vict, ch) + " forces you to '" + cmd + "'")
+        vict.send(vict.see_as(ch) + " forces you to '" + cmd + "'")
         vict.act(cmd, False)
 
 def cmd_force(ch, cmd, arg):
-    '''Usage: force <person> <action>
+    '''Usage: force <person> <command>
     
        Attempts to make the specified perform a command of your choosing.'''
     try:
         found, multi, arg = parse_args(ch, True, cmd, arg,
-                                       "ch.world.noself.multiple string")
+                                       "ch.world.noself.multiple string(command)")
     except: return
 
     if multi == False:
@@ -167,14 +182,14 @@
     ch.act("look")
     message(ch, None, None, None, True, "to_room",
             "$n appears in a puff of smoke.")
-
+    hooks.run("enter", hooks.build_info("ch rm", (ch, ch.room)))
+    
 def do_transfer(ch, tgt, dest):
     '''ch transfers tgt to dest'''
     if tgt.room == dest:
-        ch.send(tgt.name + " is already there")
+        ch.send(ch.see_as(tgt) + " is already there")
     else:
-        tgt.send(inform.see_char_as(tgt, ch) + " has transferred you to " +
-                 dest.name)
+        tgt.send(tgt.see_as(ch) + " has transferred you to " + dest.name)
         message(tgt, None, None, None, True, "to_room",
                 "$n disappears in a puff of smoke.")
         tgt.room = dest
@@ -204,19 +219,145 @@
         for tgt in found:
             do_transfer(ch, tgt, dest)
 
+def cmd_eval(ch, cmd, arg):
+    '''Usage: eval <python statement>
+
+       Evaluates a Python statement and sends its return value to the user.
+       For example:
+
+       > eval "Your name is " + ch.name
+       Evaluation: Your name is Alister
+
+       > eval dir()
+       Evaluation: ['arg', 'ch', 'cmd']
+
+       > eval dir(ch)
+       '''
+    if arg == "":
+        ch.send("What python statement do you want to evaluate?")
+    else:
+        ret = eval(arg)
+        ch.send("Evaluation: " + str(ret))
+
+def cmd_exec(ch, cmd, arg):
+    '''Usage: exec <python statement>
+
+       Execute any one-line python statement.'''
+    if arg == "":
+        ch.send("What python statement do you want to evaluate?")
+    else:
+        exec arg
+        ch.send("Command executed.")
+
+def cmd_instance(ch, cmd, arg):
+    '''Create an instanced version of the specified room'''
+    try:
+        source, dest = parse_args(ch, True, cmd, arg, "word(source) [as] word(dest)")
+    except: return
+
+    room = mudroom.instance(source, dest)
+    ch.send("You instance " + source + " as " + room.proto + ".")
+
+def do_zinstance(zone):
+    '''create a new instance of the specified zone.'''
+    # sanitize the zone key
+    if sum([(not v in string.ascii_letters+string.digits+"_") for v in zone]):
+        return None
+    elif len(zone) == 0:
+        return None
+
+    # find all of our room keys
+    rnames = mudsys.list_zone_contents(zone, "rproto")
+    if len(rnames) == 0:
+        return None
+            
+    to_instance = [ ]
+    for name in rnames:
+        key = name + "@" + zone
+        if not mudroom.is_abstract(key):
+            to_instance.append(name)
+
+    # instantiate and reset all of the relevant rooms
+    uid     = mudsys.next_uid()
+    inszone = zone + str(uid)
+    for name in to_instance:
+        key = name + "@" + zone
+        ins = name + "@" + inszone
+        rm  = mudroom.instance(key, ins)
+        rm.reset()
+
+    # append this to the list of instanced zones
+    curr_instances.append((inszone, zone))
+
+    # success
+    return inszone
+
+def cmd_zinstance(ch, cmd, arg):
+    '''create an instanced copy of the specified zone.'''
+    if arg == "":
+        if len(curr_instances) == 0:
+            ch.send("No zones currently instanced.")
+        else:
+            ch.send("{w %-40s %36s " % ("Instance", "Source"))
+            ch.send("{b-------------------------------------------------------------------------------")
+            for pair in curr_instances:
+                ch.send("{c %-40s %36s{n" % pair)
+        return
+
+    # try creating the instance, and returning the zone key
+    instance = do_zinstance(arg)
+        
+    if instance != None:
+        ch.send("Zone has been instanced with zone key, %s. zinstance for a list of current instances." % instance)
+    elif sum([(not v in string.ascii_letters+string.digits+"_") for v in arg]):
+        ch.send("Invalid zone key.")
+    elif len(mudsys.list_zone_contents(arg, "rproto")):
+        ch.send("Source zone contained no rooms to instance.")
+    else:
+        ch.send("Zone instance failed for unknown reason.")
+
+def cmd_connections(ch, cmd, arg):
+    '''lists all of the currently connected sockets, their status, and where
+       they are connected from.'''
+
+    tosend = [ ]
+
+    fmt = " %-11s %-11s %-11s %s"
+
+    tosend.append(("{w" + fmt) % ("Character", "Account", "Status", "Host"))
+    tosend.append("{b--------------------------------------------------------------------------------{c")
+    for sock in mudsock.socket_list():
+        chname  = "none"
+        accname = "none"
+        state   = sock.state
+        host    = sock.hostname
+
+        if sock.ch != None:
+            chname  = sock.ch.name
+        if sock.account != None:
+            accname = sock.account.name
+        tosend.append(fmt % (chname, accname, state, host))
+    tosend.append("{n")
+    ch.page("\r\n".join(tosend))
+
 
 
 ################################################################################
 # add our commands
 ################################################################################
-add_cmd("shutdow",  None, cmd_shutdown_net, "admin",   False)
-add_cmd("shutdown", None, cmd_shutdown,     "admin",   False)
-add_cmd("copyove",  None, cmd_copyover_net, "admin",   False)
-add_cmd("copyover", None, cmd_copyover,     "admin",   False)
-add_cmd("at",       None, cmd_at,           "admin",   False)
-add_cmd("lockdown", None, cmd_lockdown,     "admin",   False)
-add_cmd("pulserate",None, cmd_pulserate,    "admin",   False)
-add_cmd("repeat",   None, cmd_repeat,       "admin",   False)
-add_cmd("force",    None, cmd_force,        "admin",   False)
-add_cmd("goto",     None, cmd_goto,         "builder", False)
-add_cmd("transfer", None, cmd_transfer,     "builder", False)
+add_cmd("shutdow",     None, cmd_shutdown_net, "admin",   False)
+add_cmd("shutdown",    None, cmd_shutdown,     "admin",   False)
+add_cmd("copyove",     None, cmd_copyover_net, "admin",   False)
+add_cmd("copyover",    None, cmd_copyover,     "admin",   False)
+add_cmd("at",          None, cmd_at,           "wizard",  False)
+add_cmd("lockdown",    None, cmd_lockdown,     "admin",   False)
+add_cmd("pulserate",   None, cmd_pulserate,    "admin",   False)
+add_cmd("repeat",      None, cmd_repeat,       "wizard",  False)
+add_cmd("force",       None, cmd_force,        "wizard",  False)
+add_cmd("goto",        None, cmd_goto,         "wizard",  False)
+add_cmd("transfer",    None, cmd_transfer,     "wizard",  False)
+add_cmd("eval",        None, cmd_eval,         "admin",   False)
+add_cmd("exec",        None, cmd_exec,         "admin",   False)
+add_cmd("connections", None, cmd_connections,  "admin",   False)
+add_cmd("instance",    None, cmd_instance,     "admin",   False)
+add_cmd("zinstance",   None, cmd_zinstance,    "admin",   False)
